from typing import Callable, Iterable
import csv


def process_linewise(func: Callable, lines: Iterable):
    """ Iterate over lines and apply func on each """
    for line in lines:
        try:
            yield func(line)
        except ValueError:
            pass


def iterate_csv(path):
    with open(path, "r") as in_file:
        for row in csv.DictReader(in_file):
            yield row
