
def strip_n_check(arg):
    if not isinstance(arg, str):
        return str(arg) 
    stripped = arg.strip()
    if not stripped:
        raise ValueError("Empty arg")
    return stripped


def select_stmt(arg: str = "*") -> str:
    return f"SELECT {strip_n_check(arg)}"


def from_stmt(table_name: str) -> str:
    return f"FROM {strip_n_check(table_name)}"


def where_stmt(lhs: str, rhs: str, op="=") -> str:
    return f"WHERE {strip_n_check(lhs)}{strip_n_check(op)}{strip_n_check(rhs)}"


def join_stmt(lhs: str, rhs: str, key: str) -> str:
    lhs = strip_n_check(lhs)
    rhs = strip_n_check(rhs)
    key = strip_n_check(key)
    return f"{lhs} inner join {rhs} on {lhs}.{key} = {rhs}.{key}"


def table_name_query() -> str:
    return query_builder(select="name",
                         from_table="sqlite_master",
                         where_args=['type', "'table'"])


def query_builder(*, select: str = "*", from_table: str, where_args=[]) -> str:
    ret = f"{select_stmt(select)} {from_stmt(from_table)}"
    if where_args:
        ret += f" {where_stmt(*where_args)}"
    return ret
